<template>
  <div class="column is-3">
    <h1 class="title">Sign Up</h1>
    <form @submit.prevent class="form">
      <b-field>
        <b-input
          v-model="user.name"
          type="text"
          placeholder="Username"
          maxlength="30" />
      </b-field>
      <b-field>
        <b-input
          v-model="user.email"
          type="email"
          placeholder="Email Address"
          maxlength="30" />
      </b-field>
      <b-field>
        <b-input
          v-model="user.password"
          type="password"
          placeholder="Password"
          password-reveal />
      </b-field>
      <div class="field is-grouped">
        <p class="control is-expanded">
          <button
            class="button is-info is-outlined"
            @click="signUp">
            Sign Up
          </button>
        </p>
        <p class="control">
          <button
            class="button is-light"
            @click="$emit('login')">
            Login
          </button>
        </p>
      </div>
    </form>
  </div>
</template>

<script>
import SIGNUP_USER_MUTATION from '@/graphql/Auth/SignUp.gql'
export default {
  data: () => ({
    user: {}
  }),
  methods: {
    signUp () {
      this.$apollo.mutate({
        mutation: SIGNUP_USER_MUTATION,
        variables: this.user
      }).then(({ data: { signup } }) => {
        this.$auth.onLogin(signup.token, signup.user.id)
        this.$router.push({ name: 'authenticate' })
      }).catch(err => {
        console.error(err)
        this.$dialog.alert({
          title: 'Error',
          message: `Whoops! Something went wrong. ${err.message.split(':')[1]}`,
          type: 'is-danger',
          hasIcon: true,
          icon: 'times-circle'
        })
      })
    }
  }
}
</script>

<style type="scss" scoped>
  .is-3 {
    margin-top: 2rem;
  }
</style>
